﻿using System;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using YTxCommon.App.Enums;

namespace ServerAppAPI.API.Common {
    public class ClientInfo {
        public string Phone { get; set; }
        public string Email { get; set; }
        public string Name { get; set; }
        public DateTime? Birthdate { get; set; }

        [JsonConverter( typeof( StringEnumConverter ) )]
        public Gender Gender { get; set; }

        [JsonConverter( typeof( StringEnumConverter ) )]
        public CarClasses? CarClass { get; set; }

        public string DefaultAccountName { get; set; }
        public bool NoSMS { get; set; }
        public int OrdersCnt { get; set; }
        public int CancelledOrdersCnt { get; set; }
        public string LoyalCardNum { get; set; }
        public string LoyalProgName { get; set; }
        public int LoyalBalance { get; set; }
        public bool LoyalCardPasswordProtected { get; set; }
        public string NonCashCardNum { get; set; }
        public string NonCashPartnerRegNum { get; set; }
        public string NonCashPartnerName { get; set; }
        public string StandardAddress { get; set; }
        public int? StandardTownId { get; set; }
        public string StandardTownName { get; set; }
        public int? StandardStreetId { get; set; }
        public string StandardStreetName { get; set; }
        public string StandardHouse { get; set; }
        public string StandardPorch { get; set; }
        public string StandardApart { get; set; }
        public string StandardMeet { get; set; }
        public double StandardGPSlat { get; set; }
        public double StandardGPSlon { get; set; }
        public string Info { get; set; }

        [JsonConverter( typeof( StringEnumConverter ) )]
        public ClientStt Stt { get; set; }

        public string SttNote { get; set; }
        public bool Active { get; set; }
        public bool BlackListWarning { get; set; }
        public bool BlackListError { get; set; }

        public ClientAccount[] Accounts { get; set; }
    }

    public class ClientAccount {
        public int AccountId { get; set; }
        public string Name { get; set; }
        public string BankCardNumber { get; set; }
        public string PaymentPhone { get; set; }

        [JsonConverter( typeof( StringEnumConverter ) )]
        public PaymentSystems PaymentSystem { get; set; }

        public bool? PaymentSystemRegResult { get; set; }

        public string Note { get; set; }
        public bool Active { get; set; }
        public bool Available { get; set; }
    }
}
