﻿using System;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using YTxCommon.App.Enums;

namespace ServerAppAPI.API.Common {
    internal class DriverInfo {
        public int ProviderId { get; set; }
        public int DriverId { get; set; }
        public string DriverName { get; set; }
        public string DriverFirstName { get; set; }
        public string DriverLastName { get; set; }
        public int DriverSign { get; set; }
        public string DriverWorkPhone { get; set; }

        [JsonConverter( typeof( StringEnumConverter ) )]
        public Gender DriverGender { get; set; }

        public int DriverWorkingPeriod { get; set; }
        public DriverShiftStt DriverStatus { get; set; }
        public OrderAssignmentToDriverStt AssignmentStatus { get; set; }
        public bool Claimed { get; set; }
        public string CarNumber { get; set; }
        public string CarMakerModel { get; set; }
        public string CarColorName { get; set; }
        public string CarEndorsements { get; set; }
        public int CarModelYear { get; set; }

        [JsonProperty( ItemConverterType = typeof( StringEnumConverter ) )]
        public CarClasses[] CarClasses { get; set; }

        [JsonProperty( ItemConverterType = typeof( StringEnumConverter ) )]
        public OrderTypes[] OrderTypes { get; set; }

        public DateTime? LastGPSReq { get; set; }
        public double GPSLat { get; set; }
        public double GPSLon { get; set; }
        public double CurrentRate { get; set; }
        public int LinearDistanceToStartPoint { get; set; }
        public int EstimatedDurationToStartPoint { get; set; }
    }
}
