﻿namespace YTxCommon.App.Enums {
    /// <summary>
    ///     Статусы отправленных сообщений
    /// </summary>
    public enum MessageStt {
        /// <summary>
        ///     Добавлено
        /// </summary>
        Created = 0,

        /// <summary>
        ///     Отправлено
        /// </summary>
        Sent = 1,

        /// <summary>
        ///     Ошибка доставки
        /// </summary>
        DeliveryError = 2,

        /// <summary>
        ///     Доставлено
        /// </summary>
        Delivered = 3,

        /// <summary>
        ///     Не доставлено
        /// </summary>
        NotDelivered = 4
    }

    /// <summary>
    ///     Способы доставки сообщений
    /// </summary>
    public enum MessageDeliveryType {
        /// <summary>
        ///     SMS
        /// </summary>
        SMS = 0,

        /// <summary>
        ///     EMail
        /// </summary>
        EMail = 1,

        /// <summary>
        ///     Голосом по телефону
        /// </summary>
        ByPhone = 2
    }

    /// <summary>
    ///     Типы сообщений
    /// </summary>
    public enum MessageType {
        /// <summary>
        ///     Обычное сообщение
        /// </summary>
        Normal = 0,

        /// <summary>
        ///     Объявление
        /// </summary>
        Advertisement = 1,

        /// <summary>
        ///     Особое внимание
        /// </summary>
        Attention = 2,

        /// <summary>
        ///     SOS
        /// </summary>
        SOS = 3
    }

    /// <summary>
    ///     Push-уведомления. Тип устройства
    /// </summary>
    public enum PushNotificationDeviceType {
        iOS = 0,

        Android = 1,

        WindowsPhone = 2
    }
}
