﻿using System;

namespace YTxCommon.App.Enums {
    /// <summary>
    ///     Типы заказа
    /// </summary>
    public enum OrderTypes {
        /// <summary>
        ///     Кондиционер
        /// </summary>
        Conditioner = 0,

        /// <summary>
        ///     Багаж в салоне
        /// </summary>
        Baggage = 1,

        /// <summary>
        ///     Можно курить
        /// </summary>
        Smoking = 2,

        /// <summary>
        ///     Встреча с табличкой
        /// </summary>
        MeetingSign = 3,

        /// <summary>
        ///     Машина с тросом
        /// </summary>
        WithRope = 4,

        /// <summary>
        ///     Машина с прикуривателем
        /// </summary>
        WithLighter = 5,

        /// <summary>
        ///     Буксировка
        /// </summary>
        Towing = 6,

        /// <summary>
        ///     Курьер
        /// </summary>
        Courier = 7,

        /// <summary>
        ///     WiFi
        /// </summary>
        WiFi = 8,

        /// <summary>
        ///     Детское кресло
        /// </summary>
        BabySeat = 9,

        /// <summary>
        ///     Домашнее животное до 5 кг
        /// </summary>
        PetTo5 = 10,

        /// <summary>
        ///     Домашнее животное более 5 кг
        /// </summary>
        PetMore5 = 11,

        /// <summary>
        ///     Багаж из дома\офиса
        /// </summary>
        TakeOut = 12,

        /// <summary>
        ///     Багаж в дом\офис
        /// </summary>
        Skid = 13,

        /// <summary>
        ///     Автоняня
        /// </summary>
        BabySitter = 14,

        /// <summary>
        ///     Английский язык
        /// </summary>
        English = 15,

        /// <summary>
        ///     Курьерская доставка
        /// </summary>
        CourierDelivery = 16,

        /// <summary>
        ///     Требуется документ на оплату заказа
        /// </summary>
        BillRequired = 17,

        /// <summary>
        ///     Требуется платёжный терминал для оплаты заказа
        /// </summary>
        TerminalRequired = 18,

        /// <summary>
        ///     4 и более человек в машине
        /// </summary>
        PassengersNumber4OrMore = 19,

        /// <summary>
        ///     Нельзя курить
        /// </summary>
        NoSmoking = 20,

        /// <summary>
        ///     Драйвер
        /// </summary>
        Driver = 21,

        /// <summary>
        ///     Эвакуатор - Тележка 1шт
        /// </summary>
        TowTruck0 = 1000,

        /// <summary>
        ///     Эвакуатор - Тележки 2шт
        /// </summary>
        TowTruck1 = 1001,

        /// <summary>
        ///     Эвакуатор - Тележки 3шт
        /// </summary>
        TowTruck2 = 1002,

        /// <summary>
        ///     Эвакуатор - Тележки 4шт
        /// </summary>
        TowTruck3 = 1003,

        /// <summary>
        ///     Эвакуатор - Повторная погрузка
        /// </summary>
        TowTruck4 = 1004,

        /// <summary>
        ///     Эвакуатор - Заблокирован руль
        /// </summary>
        TowTruck5 = 1005,

        /// <summary>
        ///     Эвакуатор - Заблокирована коробка
        /// </summary>
        TowTruck6 = 1006,

        /// <summary>
        ///     Эвакуатор - На крыше
        /// </summary>
        TowTruck7 = 1007,

        /// <summary>
        ///     Эвакуатор - На боку
        /// </summary>
        TowTruck8 = 1008,

        /// <summary>
        ///     Эвакуатор - Вытягивание из паркинга
        /// </summary>
        TowTruck9 = 1009,

        /// <summary>
        ///     Эвакуатор - Вытягивание из бездорожья
        /// </summary>
        TowTruck10 = 1010,

        /// <summary>
        ///     Кювет
        /// </summary>
        TowTruck11 = 1011,

        /// <summary>
        ///     Жесткая сцепка
        /// </summary>
        TowTruck12 = 1012,

        /// <summary>
        ///     Негабарит
        /// </summary>
        TowTruck13 = 1013,

        /// <summary>
        ///     Разблокировка коробки
        /// </summary>
        TowTruck14 = 1014,

        /// <summary>
        ///     Загрузка с рампы
        /// </summary>
        TowTruck15 = 1015,

        /// <summary>
        ///     Выгрузка на рампу
        /// </summary>
        TowTruck16 = 1016,

        /// <summary>
        ///     Загрузка на фуру
        /// </summary>
        TowTruck17 = 1017,

        /// <summary>
        ///     Выгрузка с фуры
        /// </summary>
        TowTruck18 = 1018,

        /// <summary>
        ///     Перевозка МАФов
        /// </summary>
        TowTruck19 = 1019,

        /// <summary>
        ///     Манипулятор
        /// </summary>
        TowTruck20 = 1020,

        /// <summary>
        ///     Борта
        /// </summary>
        TowTruck21 = 1021,

        /// <summary>
        ///     Фаркоп шарик
        /// </summary>
        TowTruck22 = 1022,

        /// <summary>
        ///     Фаркоп америка
        /// </summary>
        TowTruck23 = 1023,

        /// <summary>
        ///     Фаркоп
        /// </summary>
        TowTruck24 = 1024,

        /// <summary>
        ///     Вытяжка Фуры
        /// </summary>
        TowTruck25 = 1025,

        /// <summary>
        ///     Переворот Фуры
        /// </summary>
        TowTruck26 = 1026,

        /// <summary>
        ///     Перевозка Фуры
        /// </summary>
        TowTruck27 = 1027,

        /// <summary>
        ///     Гидравлика
        /// </summary>
        TowTruck28 = 1028,

        /// <summary>
        ///     Высота платформы до 80см
        /// </summary>
        TowTruck29 = 1029,

        /// <summary>
        ///     Высота платформы до 1м
        /// </summary>
        TowTruck30 = 1030,

        /// <summary>
        ///     Ровная платформа 5м
        /// </summary>
        TowTruck31 = 1031,

        /// <summary>
        ///     Ровная платформа 6м
        /// </summary>
        TowTruck32 = 1032,

        /// <summary>
        ///     Ровная платформа 6,5м
        /// </summary>
        TowTruck33 = 1033,

        /// <summary>
        ///     Ровная платформа 7м
        /// </summary>
        TowTruck34 = 1034,

        /// <summary>
        ///     Ровная платформа 7,5м
        /// </summary>
        TowTruck35 = 1035,

        /// <summary>
        ///     Ровная платформа 8м
        /// </summary>
        TowTruck36 = 1036,

        /// <summary>
        ///     Дать воздух
        /// </summary>
        TowTruck37 = 1037,

        /// <summary>
        ///     Трал
        /// </summary>
        TowTruck38 = 1038,

        /// <summary>
        ///     Маленькую маш.
        /// </summary>
        TowTruck39 = 1039,

        /// <summary>
        ///     Сложный заезд
        /// </summary>
        TowTruck40 = 1040,

        /// <summary>
        ///     Узкий заезд
        /// </summary>
        TowTruck41 = 1041,

        /// <summary>
        ///     Низкий заезд
        /// </summary>
        TowTruck42 = 1042,

        /// <summary>
        ///     Широкая ТАТА
        /// </summary>
        TowTruck43 = 1043,

        /// <summary>
        ///     Сдвигающиеся лапы
        /// </summary>
        TowTruck44 = 1044,

        /// <summary>
        ///     Дернуть (Завести)
        /// </summary>
        TowTruck45 = 1045,

        /// <summary>
        ///     Догруз
        /// </summary>
        TowTruck46 = 1046,

        /// <summary>
        ///     Умного водителя
        /// </summary>
        TowTruck47 = 1047,

        /// <summary>
        ///     Техпомощь
        /// </summary>
        TowTruck48 = 1048,

        /// <summary>
        ///     Техпомощь на дороге
        /// </summary>
        TowTruck49 = 1049,

        /// <summary>
        ///     Снятие кардана
        /// </summary>
        TowTruck50 = 1050,

        /// <summary>
        ///     Снятие энергоаккумуляторов
        /// </summary>
        TowTruck51 = 1051,

        /// <summary>
        ///     Переставить автокраном
        /// </summary>
        TowTruck52 = 1052,

        /// <summary>
        ///     Достать авто из ямы
        /// </summary>
        TowTruck53 = 1053,

        /// <summary>
        ///     Мощный кран
        /// </summary>
        TowTruck54 = 1054,

        /// <summary>
        ///     Прикурка
        /// </summary>
        TowTruck55 = 1055,

        /// <summary>
        ///     Открытие авто
        /// </summary>
        TowTruck56 = 1056,

        /// <summary>
        ///     Открытие КВ.
        /// </summary>
        TowTruck57 = 1057,

        /// <summary>
        ///     Замена кол.
        /// </summary>
        TowTruck58 = 1058,

        /// <summary>
        ///     Подвоз АКБ
        /// </summary>
        TowTruck59 = 1059,

        /// <summary>
        ///     Замена АКБ
        /// </summary>
        TowTruck60 = 1060,

        /// <summary>
        ///     Рем. замка зажигания
        /// </summary>
        TowTruck61 = 1061,

        /// <summary>
        ///     Установка замков
        /// </summary>
        TowTruck62 = 1062,

        /// <summary>
        ///     Вскрытие сейфа
        /// </summary>
        TowTruck63 = 1063,

        /// <summary>
        ///     Откл. сигнализацию
        /// </summary>
        TowTruck64 = 1064,

        /// <summary>
        ///     Сделать ключи
        /// </summary>
        TowTruck65 = 1065,

        /// <summary>
        ///     Перепрошить брелок
        /// </summary>
        TowTruck66 = 1066,

        /// <summary>
        ///     Подвоз топлива
        /// </summary>
        TowTruck67 = 1067,

        /// <summary>
        ///     Разблокировка руля
        /// </summary>
        TowTruck68 = 1068,

        /// <summary>
        ///     Зам. кол. на фуре
        /// </summary>
        TowTruck69 = 1069,

        /// <summary>
        ///     Грузчики
        /// </summary>
        TowTruck70 = 1070,

        /// <summary>
        ///     Стропальщик
        /// </summary>
        TowTruck71 = 1071,

        /// <summary>
        ///     Другие услуги
        /// </summary>
        TowTruck72 = 1072,

        /// <summary>
        ///     Встреча с клиентом в Киеве
        /// </summary>
        TowTruck73 = 1073,

        /// <summary>
        ///     Подкачка кол.
        /// </summary>
        TowTruck74 = 1074,

        /// <summary>
        ///     По дороге забрать клиента
        /// </summary>
        TowTruck75 = 1075,

        /// <summary>
        ///     Экспедиторские Услуги
        /// </summary>
        TowTruck76 = 1076,

        /// <summary>
        ///     Прицеп 1+1
        /// </summary>
        TowTruck77 = 1077,

        /// <summary>
        ///     Прицеп 1+2
        /// </summary>
        TowTruck78 = 1078,

        /// <summary>
        ///     Прицеп 1+3
        /// </summary>
        TowTruck79 = 1079,

        /// <summary>
        ///     Прицеп 2+2
        /// </summary>
        TowTruck80 = 1080,

        /// <summary>
        ///     Прицеп 2+3
        /// </summary>
        TowTruck81 = 1081,

        /// <summary>
        ///     Много ремней
        /// </summary>
        TowTruck82 = 1082,

        /// <summary>
        ///     Дополнительные тросы
        /// </summary>
        TowTruck83 = 1083,

        /// <summary>
        ///     Мотоцикл 2-х кол.
        /// </summary>
        TowTruck84 = 1084,

        /// <summary>
        ///     Мотоцикл 3-х кол.
        /// </summary>
        TowTruck85 = 1085,

        /// <summary>
        ///     Больше 2-х чел.
        /// </summary>
        TowTruck86 = 1086,

        /// <summary>
        ///     Частичная погрузка
        /// </summary>
        TowTruck87 = 1087,

        /// <summary>
        ///     Колеса оторваны
        /// </summary>
        TowTruck88 = 1088,

        /// <summary>
        ///     Колеса заблокированы
        /// </summary>
        TowTruck89 = 1089,

        /// <summary>
        ///     Негабарит, решаем мы
        /// </summary>
        TowTruck90 = 1090,

        /// <summary>
        ///     Негабарит, решает клиент
        /// </summary>
        TowTruck91 = 1091,

        /// <summary>
        ///     Пользовательский тип 0
        /// </summary>
        Custom000 = 2000,

        /// <summary>
        ///     Пользовательский тип 1
        /// </summary>
        Custom001 = 2001,

        /// <summary>
        ///     Пользовательский тип 2
        /// </summary>
        Custom002 = 2002,

        /// <summary>
        ///     Пользовательский тип 3
        /// </summary>
        Custom003 = 2003,

        /// <summary>
        ///     Пользовательский тип 4
        /// </summary>
        Custom004 = 2004,

        /// <summary>
        ///     Пользовательский тип 5
        /// </summary>
        Custom005 = 2005,

        /// <summary>
        ///     Пользовательский тип 6
        /// </summary>
        Custom006 = 2006,

        /// <summary>
        ///     Пользовательский тип 7
        /// </summary>
        Custom007 = 2007,

        /// <summary>
        ///     Пользовательский тип 8
        /// </summary>
        Custom008 = 2008,

        /// <summary>
        ///     Пользовательский тип 9
        /// </summary>
        Custom009 = 2009,

        /// <summary>
        ///     Пользовательский тип 10
        /// </summary>
        Custom010 = 2010,

        /// <summary>
        ///     Пользовательский тип 11
        /// </summary>
        Custom011 = 2011,

        /// <summary>
        ///     Пользовательский тип 12
        /// </summary>
        Custom012 = 2012,

        /// <summary>
        ///     Пользовательский тип 13
        /// </summary>
        Custom013 = 2013,

        /// <summary>
        ///     Пользовательский тип 14
        /// </summary>
        Custom014 = 2014,

        /// <summary>
        ///     Пользовательский тип 15
        /// </summary>
        Custom015 = 2015,

        /// <summary>
        ///     Пользовательский тип 16
        /// </summary>
        Custom016 = 2016,

        /// <summary>
        ///     Пользовательский тип 17
        /// </summary>
        Custom017 = 2017,

        /// <summary>
        ///     Пользовательский тип 18
        /// </summary>
        Custom018 = 2018,

        /// <summary>
        ///     Пользовательский тип 19
        /// </summary>
        Custom019 = 2019,

        /// <summary>
        ///     Пользовательский тип 20
        /// </summary>
        Custom020 = 2020,

        /// <summary>
        ///     Пользовательский тип 21
        /// </summary>
        Custom021 = 2021,

        /// <summary>
        ///     Пользовательский тип 22
        /// </summary>
        Custom022 = 2022,

        /// <summary>
        ///     Пользовательский тип 23
        /// </summary>
        Custom023 = 2023,

        /// <summary>
        ///     Пользовательский тип 24
        /// </summary>
        Custom024 = 2024,

        /// <summary>
        ///     Пользовательский тип 25
        /// </summary>
        Custom025 = 2025,

        /// <summary>
        ///     Пользовательский тип 26
        /// </summary>
        Custom026 = 2026,

        /// <summary>
        ///     Пользовательский тип 27
        /// </summary>
        Custom027 = 2027,

        /// <summary>
        ///     Пользовательский тип 28
        /// </summary>
        Custom028 = 2028,

        /// <summary>
        ///     Пользовательский тип 29
        /// </summary>
        Custom029 = 2029,

        /// <summary>
        ///     Пользовательский тип 30
        /// </summary>
        Custom030 = 2030,

        /// <summary>
        ///     Пользовательский тип 31
        /// </summary>
        Custom031 = 2031,

        /// <summary>
        ///     Пользовательский тип 32
        /// </summary>
        Custom032 = 2032,

        /// <summary>
        ///     Пользовательский тип 33
        /// </summary>
        Custom033 = 2033,

        /// <summary>
        ///     Пользовательский тип 34
        /// </summary>
        Custom034 = 2034,

        /// <summary>
        ///     Пользовательский тип 35
        /// </summary>
        Custom035 = 2035,

        /// <summary>
        ///     Пользовательский тип 36
        /// </summary>
        Custom036 = 2036,

        /// <summary>
        ///     Пользовательский тип 37
        /// </summary>
        Custom037 = 2037,

        /// <summary>
        ///     Пользовательский тип 38
        /// </summary>
        Custom038 = 2038,

        /// <summary>
        ///     Пользовательский тип 39
        /// </summary>
        Custom039 = 2039,

        /// <summary>
        ///     Пользовательский тип 40
        /// </summary>
        Custom040 = 2040,

        /// <summary>
        ///     Пользовательский тип 41
        /// </summary>
        Custom041 = 2041,

        /// <summary>
        ///     Пользовательский тип 42
        /// </summary>
        Custom042 = 2042,

        /// <summary>
        ///     Пользовательский тип 43
        /// </summary>
        Custom043 = 2043,

        /// <summary>
        ///     Пользовательский тип 44
        /// </summary>
        Custom044 = 2044,

        /// <summary>
        ///     Пользовательский тип 45
        /// </summary>
        Custom045 = 2045,

        /// <summary>
        ///     Пользовательский тип 46
        /// </summary>
        Custom046 = 2046,

        /// <summary>
        ///     Пользовательский тип 47
        /// </summary>
        Custom047 = 2047,

        /// <summary>
        ///     Пользовательский тип 48
        /// </summary>
        Custom048 = 2048,

        /// <summary>
        ///     Пользовательский тип 49
        /// </summary>
        Custom049 = 2049,

        /// <summary>
        ///     Пользовательский тип 50
        /// </summary>
        Custom050 = 2050,

        /// <summary>
        ///     Пользовательский тип 51
        /// </summary>
        Custom051 = 2051,

        /// <summary>
        ///     Пользовательский тип 52
        /// </summary>
        Custom052 = 2052,

        /// <summary>
        ///     Пользовательский тип 53
        /// </summary>
        Custom053 = 2053,

        /// <summary>
        ///     Пользовательский тип 54
        /// </summary>
        Custom054 = 2054,

        /// <summary>
        ///     Пользовательский тип 55
        /// </summary>
        Custom055 = 2055,

        /// <summary>
        ///     Пользовательский тип 56
        /// </summary>
        Custom056 = 2056,

        /// <summary>
        ///     Пользовательский тип 57
        /// </summary>
        Custom057 = 2057,

        /// <summary>
        ///     Пользовательский тип 58
        /// </summary>
        Custom058 = 2058,

        /// <summary>
        ///     Пользовательский тип 59
        /// </summary>
        Custom059 = 2059,

        /// <summary>
        ///     Пользовательский тип 60
        /// </summary>
        Custom060 = 2060,

        /// <summary>
        ///     Пользовательский тип 61
        /// </summary>
        Custom061 = 2061,

        /// <summary>
        ///     Пользовательский тип 62
        /// </summary>
        Custom062 = 2062,

        /// <summary>
        ///     Пользовательский тип 63
        /// </summary>
        Custom063 = 2063,

        /// <summary>
        ///     Пользовательский тип 64
        /// </summary>
        Custom064 = 2064,

        /// <summary>
        ///     Пользовательский тип 65
        /// </summary>
        Custom065 = 2065,

        /// <summary>
        ///     Пользовательский тип 66
        /// </summary>
        Custom066 = 2066,

        /// <summary>
        ///     Пользовательский тип 67
        /// </summary>
        Custom067 = 2067,

        /// <summary>
        ///     Пользовательский тип 68
        /// </summary>
        Custom068 = 2068,

        /// <summary>
        ///     Пользовательский тип 69
        /// </summary>
        Custom069 = 2069,

        /// <summary>
        ///     Пользовательский тип 70
        /// </summary>
        Custom070 = 2070,

        /// <summary>
        ///     Пользовательский тип 71
        /// </summary>
        Custom071 = 2071,

        /// <summary>
        ///     Пользовательский тип 72
        /// </summary>
        Custom072 = 2072,

        /// <summary>
        ///     Пользовательский тип 73
        /// </summary>
        Custom073 = 2073,

        /// <summary>
        ///     Пользовательский тип 74
        /// </summary>
        Custom074 = 2074,

        /// <summary>
        ///     Пользовательский тип 75
        /// </summary>
        Custom075 = 2075,

        /// <summary>
        ///     Пользовательский тип 76
        /// </summary>
        Custom076 = 2076,

        /// <summary>
        ///     Пользовательский тип 77
        /// </summary>
        Custom077 = 2077,

        /// <summary>
        ///     Пользовательский тип 78
        /// </summary>
        Custom078 = 2078,

        /// <summary>
        ///     Пользовательский тип 79
        /// </summary>
        Custom079 = 2079,

        /// <summary>
        ///     Пользовательский тип 80
        /// </summary>
        Custom080 = 2080,

        /// <summary>
        ///     Пользовательский тип 81
        /// </summary>
        Custom081 = 2081,

        /// <summary>
        ///     Пользовательский тип 82
        /// </summary>
        Custom082 = 2082,

        /// <summary>
        ///     Пользовательский тип 83
        /// </summary>
        Custom083 = 2083,

        /// <summary>
        ///     Пользовательский тип 84
        /// </summary>
        Custom084 = 2084,

        /// <summary>
        ///     Пользовательский тип 85
        /// </summary>
        Custom085 = 2085,

        /// <summary>
        ///     Пользовательский тип 86
        /// </summary>
        Custom086 = 2086,

        /// <summary>
        ///     Пользовательский тип 87
        /// </summary>
        Custom087 = 2087,

        /// <summary>
        ///     Пользовательский тип 88
        /// </summary>
        Custom088 = 2088,

        /// <summary>
        ///     Пользовательский тип 89
        /// </summary>
        Custom089 = 2089,

        /// <summary>
        ///     Пользовательский тип 90
        /// </summary>
        Custom090 = 2090,

        /// <summary>
        ///     Пользовательский тип 91
        /// </summary>
        Custom091 = 2091,

        /// <summary>
        ///     Пользовательский тип 92
        /// </summary>
        Custom092 = 2092,

        /// <summary>
        ///     Пользовательский тип 93
        /// </summary>
        Custom093 = 2093,

        /// <summary>
        ///     Пользовательский тип 94
        /// </summary>
        Custom094 = 2094,

        /// <summary>
        ///     Пользовательский тип 95
        /// </summary>
        Custom095 = 2095,

        /// <summary>
        ///     Пользовательский тип 96
        /// </summary>
        Custom096 = 2096,

        /// <summary>
        ///     Пользовательский тип 97
        /// </summary>
        Custom097 = 2097,

        /// <summary>
        ///     Пользовательский тип 98
        /// </summary>
        Custom098 = 2098,

        /// <summary>
        ///     Пользовательский тип 99
        /// </summary>
        Custom099 = 2099
    }

    /// <summary>
    ///     Виды статусов заказа
    /// </summary>
    public enum OrderStt {
        /// <summary>
        ///     Создан
        /// </summary>
        Created = 0,

        /// <summary>
        ///     Поиск машины
        /// </summary>
        CarSearch = 1,

        /// <summary>
        ///     Подача машины
        /// </summary>
        CarOnRoad = 2,

        /// <summary>
        ///     Машина ожидает клиента
        /// </summary>
        CarWaiting = 3,

        /// <summary>
        ///     Заказ выполняется
        /// </summary>
        InProgress = 4,

        /// <summary>
        ///     Заказ завершён
        /// </summary>
        Complete = 5,

        /// <summary>
        ///     Заказ отменён
        /// </summary>
        Cancelled = 6,

        /// <summary>
        ///     Заказ завершён успешно и закрыт
        /// </summary>
        CompleteSuccessfully = 100,

        /// <summary>
        ///     Заказ завершён неуспешно и закрыт
        /// </summary>
        CompleteUnsuccessfully = 101
    }

    /// <summary>
    ///     Виды подчинённых статусов заказа
    ///     Структура: OrderStt-N знаков, OrderSubStt-3 знака
    /// </summary>
    public enum OrderSubStt {
        /// <summary>
        ///     Создан - Заказ создан
        /// </summary>
        CreatedCreated = 0,

        /// <summary>
        ///     Создан - Выполняется расчёт
        /// </summary>
        CreatedCalculating = 1,

        /// <summary>
        ///     Создан - Ожидается подтверждение клиента
        /// </summary>
        CreatedClientConfirmation = 2,

        /// <summary>
        ///     Поиск машины - Оценка вероятности выполнения заказа
        /// </summary>
        CarSearchEstimate = 1001,

        /// <summary>
        ///     Поиск машины - Автоматический поиск
        /// </summary>
        CarSearchAuto = 1002,

        /// <summary>
        ///     Поиск машины - Клиент выбирает автомобили из предложенных
        /// </summary>
        CarSearchClientSelect = 1003,

        /// <summary>
        ///     Поиск машины - Клиент ожидает ответ водителя (подтверждение или отказ)
        /// </summary>
        CarSearchClientWaitingAnswer = 1004,

        /// <summary>
        ///     Поиск машины - Диспетчер ищет машину вручную
        /// </summary>
        CarSearchByDispatcher = 1005,

        /// <summary>
        ///     Поиск машины - Заказ передан в "Свободный эфир"
        /// </summary>
        CarSearchBroadcast = 1006,

        /// <summary>
        ///     Подача машины - Водитель подтвердил приём заказа в работу
        /// </summary>
        CarOnRoadDriverConfirmed = 2001,

        /// <summary>
        ///     Подача машины - Диспетчер подтвердил водителя
        /// </summary>
        CarOnRoadDriverStarts = 2002,

        /// <summary>
        ///     Подача машины - Водитель опаздывает
        /// </summary>
        CarOnRoadDriverIsLate = 2003,

        /// <summary>
        ///     Ожидание клиента - Машина прибыла в исходный пункт
        /// </summary>
        CarWaitingDriverArrived = 3001,

        /// <summary>
        ///     Ожидание клиента - Клиент уведомлён о прибытии машины
        /// </summary>
        CarWaitingClientNotified = 3002,

        /// <summary>
        ///     Ожидание клиента - Запуск таксометра для начисления простоя
        /// </summary>
        CarWaitingIdleCharges = 3003,

        /// <summary>
        ///     Заказ выполняется - Посадка клиента
        /// </summary>
        InProgressWithClient = 4001,

        /// <summary>
        ///     Заказ выполняется - Запуск таксометра и начало движения по маршруту
        /// </summary>
        InProgressStartTaximeter = 4002,

        /// <summary>
        ///     Заказ завершён - Остановка таксометра. Ожидается оплата
        /// </summary>
        CompleteWaitPay = 5001,

        /// <summary>
        ///     Заказ отменён - Машина не найдена
        /// </summary>
        CancelledCarNotFound = 6001,

        /// <summary>
        ///     Заказ отменён - Клиент не вышел
        /// </summary>
        CancelledClientNotOut = 6002,

        /// <summary>
        ///     Заказ отменён - Отказ водителя
        /// </summary>
        CancelledDriverRejection = 6003,

        /// <summary>
        ///     Заказ отменён - Отказ клиента
        /// </summary>
        CancelledClientRejection = 6004,

        /// <summary>
        ///     Заказ завершён успешно - Клиент оплатил заказ
        /// </summary>
        CompleteSuccessfullyPayed = 100001,

        /// <summary>
        ///     Заказ завершён успешно - Оплата подачи машины
        /// </summary>
        CompleteSuccessfullyFilingFeesCar = 100002,

        /// <summary>
        ///     Заказ завершён неуспешно - Машина не найдена
        /// </summary>
        CompleteUnsuccessfullyCarNotFound = 101001,

        /// <summary>
        ///     Заказ завершён неуспешно - Отказ клиента
        /// </summary>
        CompleteUnsuccessfullyClientRejection = 101002,

        /// <summary>
        ///     Заказ завершён неуспешно - Просчёт тарифа
        /// </summary>
        CompleteUnsuccessfullyInvalidCalculation = 101003,

        /// <summary>
        ///     Заказ завершён неуспешно - Вина оператора
        /// </summary>
        CompleteUnsuccessfullyOperatorGuilty = 101004,

        /// <summary>
        ///     Заказ завершён неуспешно - Вина водителя
        /// </summary>
        CompleteUnsuccessfullyDriverGuilty = 101005,

        /// <summary>
        ///     Заказ завершён неуспешно - Просчёт маршрута (Дорого)
        /// </summary>
        CompleteUnsuccessfullyInvalidRoute = 101006,

        /// <summary>
        ///     Заказ завершён неуспешно - Клиент не выбрал автомобиль
        /// </summary>
        CompleteUnsuccessfullyClientNotSelect = 101007,

        /// <summary>
        ///     Заказ завершён неуспешно - Отмена быстрого автопоиска
        /// </summary>
        CompleteUnsuccessfullyCarSearchCancellation = 101008
    }

    /// <summary>
    ///     Источники заказа
    /// </summary>
    public enum OrderSources {
        /// <summary>
        ///     Телефон (зарегистрирован оператором)
        /// </summary>
        Phone = 0,

        /// <summary>
        ///     Программа (зарегистрирован программно)
        /// </summary>
        Software = 1,

        /// <summary>
        ///     Свободный заказ (зарегистрирован водителем)
        /// </summary>
        Driver = 2
    }

    /// <summary>
    ///     Детализация источников заказа
    /// </summary>
    public enum OrderSourceDetails {
        /// <summary>
        ///     Мобильное/стационарное приложение (Программа)
        /// </summary>
        NativeApp = 0,

        /// <summary>
        ///     Web-приложение (Сайт)
        /// </summary>
        WebApp = 1
    }

    /// <summary>
    ///     Приоритет заказа
    /// </summary>
    public enum OrderPriority {
        /// <summary>
        ///     Незначительный
        /// </summary>
        Minor = -2,

        /// <summary>
        ///     Низкий
        /// </summary>
        Low = -1,

        /// <summary>
        ///     Обычный
        /// </summary>
        Normal = 0,

        /// <summary>
        ///     Высокий
        /// </summary>
        High = 1,

        /// <summary>
        ///     Высший
        /// </summary>
        Top = 2,

        /// <summary>
        ///     Неотложный
        /// </summary>
        Urgent = 3
    }

    /// <summary>
    ///     Типы событий заказа
    /// </summary>
    public enum OrderEvents {
        /// <summary>
        ///     Создание
        /// </summary>
        Create = 0,

        /// <summary>
        ///     Изменение статуса
        /// </summary>
        Change = 1,

        /// <summary>
        ///     Закрытие
        /// </summary>
        Closure = 2,

        /// <summary>
        ///     Восстановление
        /// </summary>
        Restore = 3,

        /// <summary>
        ///     Назначение водителя на заказ
        /// </summary>
        DriverAppointment = 4,

        /// <summary>
        ///     Снятие водителя с заказа
        /// </summary>
        DriverDisappointment = 5,

        /// <summary>
        ///     Сброс времени заказа
        /// </summary>
        TimeReset = 6,

        /// <summary>
        ///     Редактирование
        /// </summary>
        Modify = 7,

        /// <summary>
        ///     Редактирование архивной записи
        /// </summary>
        ModifyArchived = 8,

        /// <summary>
        ///     Заказ отправлен на обмен
        /// </summary>
        XchgProcessing = 9,

        /// <summary>
        ///     Заказ принят к исполнению по обмену
        /// </summary>
        XchgTaken = 10,

        /// <summary>
        ///     Заказ возвращён из обмена
        /// </summary>
        XchgRecovered = 11,

        /// <summary>
        ///     Сообщение для заказа по обмену
        /// </summary>
        XchgMessage = 12,

        /// <summary>
        ///     Изменение пометки заказа
        /// </summary>
        NoteChanged = 13,

        /// <summary>
        ///     Подтверждение оплаты заказа внешней системой
        /// </summary>
        PaymentDone = 14,

        /// <summary>
        ///     Смена диспетчера
        /// </summary>
        DispatcherChange = 15,

        /// <summary>
        ///     Отказ водителя
        /// </summary>
        DriverRejection = 16,

        /// <summary>
        ///     Определена дата и время начала выполнения заказа
        /// </summary>
        StartTimeDefined = 17,

        /// <summary>
        ///     Водитель не может выполнить заказ
        /// </summary>
        DriverCanNotPerformOrder = 18,

        /// <summary>
        ///     Баланс водителя ниже порога отключения
        /// </summary>
        DriverBalanceIsTooLow = 19,

        /// <summary>
        ///     Водитель не принимает заказы, оплачиваемые банковской карточкой
        /// </summary>
        DriverNotAcceptBankCard = 20,

        /// <summary>
        ///     Водитель не обслуживает клиента
        /// </summary>
        DriverClientDisabled = 21,

        /// <summary>
        ///     Клиент не обслуживается у водителя
        /// </summary>
        ClientDriverDisabled = 22,

        /// <summary>
        ///     Водитель уведомлён о предложенном заказе
        /// </summary>
        DriverNotifiedAboutProposedOrder = 23,

        /// <summary>
        ///     Водитель уведомлён о требуемом заказе
        /// </summary>
        DriverNotifiedAboutClaimedOrder = 24,

        /// <summary>
        ///     Водитель отказался от предложенного заказа
        /// </summary>
        DriverRejectsProposedOrder = 25,

        /// <summary>
        ///     Водитель отказался от требуемого заказа
        /// </summary>
        DriverRejectsClaimedOrder = 26,

        /// <summary>
        ///     С водителя снят по таймауту предложенный заказ
        /// </summary>
        DriverTimedOutProposedOrder = 27,

        /// <summary>
        ///     С водителя снят по таймауту требуемый заказ
        /// </summary>
        DriverTimedOutClaimedOrder = 28,

        /// <summary>
        ///     Выход из приложения водителя во время выполнения заказа
        /// </summary>
        ApplicationExited = 29,

        /// <summary>
        ///     Закрытие приложения водителя во время выполнения заказа
        /// </summary>
        ApplicationClosed = 30,

        /// <summary>
        ///     Отключение GPS во время выполнения заказа
        /// </summary>
        GpsTurnedOff = 31,

        /// <summary>
        ///     Переключение заказа на расчёт по таксометру
        /// </summary>
        SwitchToTaximeter = 32,

        /// <summary>
        ///     Отмена расчёта заказа по таксометру
        /// </summary>
        CancellationTaximeter = 33,

        /// <summary>
        ///     Возврат в приложение водителя во время выполнения заказа
        /// </summary>
        ApplicationOpened = 34,

        /// <summary>
        ///     Отправка SMS клиенту
        /// </summary>
        SendSMSToClient = 35,

        /// <summary>
        ///     Отправка SMS водителю
        /// </summary>
        SendSMSToDriver = 36,

        /// <summary>
        ///     Отправка голосового сообщения клиенту
        /// </summary>
        SendVoiceMessage = 37,

        /// <summary>
        ///     Отправка push-уведомления клиенту
        /// </summary>
        SendPushMessage = 38
    }

    /// <summary>
    ///     Статусы назначения заказа водителю
    /// </summary>
    public enum OrderAssignmentToDriverStt {
        /// <summary>
        ///     Не назначен
        /// </summary>
        None = 0,

        /// <summary>
        ///     Отказ водителя
        /// </summary>
        Rejected = 1,

        /// <summary>
        ///     Предложение выполнения
        /// </summary>
        Proposed = 2,

        /// <summary>
        ///     Требование выполнения
        /// </summary>
        Claimed = 3
    }

    /// <summary>
    ///     Ошибки назначения статуса заказа
    /// </summary>
    public enum SetOrderStatusErrors {
        /// <summary>
        ///     На заказ не назначен водитель
        /// </summary>
        DriverIsUndefined = 0,

        /// <summary>
        ///     Водитель отсутствует или не на смене
        /// </summary>
        DriverIsAbsentOnShift = 1
    }

    /// <summary>
    ///     Причины завершения приложения водителя
    /// </summary>
    public enum DriverApplicationExitCause {
        /// <summary>
        ///     Выход из приложения водителя во время выполнения заказа
        /// </summary>
        ApplicationExited = 0,

        /// <summary>
        ///     Закрытие приложения водителя во время выполнения заказа
        /// </summary>
        ApplicationClosed = 1,

        /// <summary>
        ///     Отключение GPS во время выполнения заказа
        /// </summary>
        GpsTurnedOff = 2
    }

    /// <summary>
    ///     Операции программы обработки событий заказа
    /// </summary>
    public enum OrderEventProgramActions {
        /// <summary>
        ///     Получить следующий статус заказа
        /// </summary>
        NextOrderStatusRequest = 0,

        /// <summary>
        ///     Статус заказа установлен
        /// </summary>
        OrderStatusEstablished = 1,

        /// <summary>
        ///     Заказ ожидает следующее событие
        /// </summary>
        OrderIsWaitingInStatus = 2,

        /// <summary>
        ///     Отправить SMS-сообщение водителю
        /// </summary>
        SendSMSToDriver = 3,

        /// <summary>
        ///     Пользователь выбрал водителя
        /// </summary>
        OrderDriverSelected = 4,

        /// <summary>
        ///     Отправить SMS-сообщение клиенту
        /// </summary>
        SendSMSToClient = 5,

        /// <summary>
        ///     Водитель опаздывает
        /// </summary>
        DriverIsLate = 6,

        /// <summary>
        ///     Определение возможности выполнения заказа водителем
        /// </summary>
        OrderEstimate = 7,

        /// <summary>
        ///     Назначение рейтинга заказу
        /// </summary>
        OrderDriverRatingSet = 8,

        /// <summary>
        ///     Регистрация собственного заказа водителем
        /// </summary>
        DriverRegisterOwnOrder = 9,

        /// <summary>
        ///     Закрытие собственного заказа водителем
        /// </summary>
        DriverCloseOwnOrder = 10,

        /// <summary>
        ///     Проверка внешнего статуса заказа
        /// </summary>
        OrderExternStatusCheck = 11,

        /// <summary>
        ///     Передача заказа в обмен
        /// </summary>
        OrderSendToXchg = 12,

        /// <summary>
        ///     Обработка команды от сервера телефонии
        /// </summary>
        OrderPBXCommand = 13,

        /// <summary>
        ///     Водитель снят с заказа
        /// </summary>
        DriverDisappointFromOrder = 14,

        /// <summary>
        ///     Проверка заказа на приближение к "домашнему адресу" водителя
        /// </summary>
        OrderToHomeState = 15,

        /// <summary>
        ///     Запланированное событие по заказу
        /// </summary>
        OrderScheduledEvent = 16,

        /// <summary>
        ///     Вызов телефонии для заказа
        /// </summary>
        OrderPBXInvoke = 17,

        /// <summary>
        ///     Корректировка стоимости заказа водителем
        /// </summary>
        DriverUpdatePayment = 18,

        /// <summary>
        ///     Завершение приложения водителя во время выполнения заказа
        /// </summary>
        DriverApplicationExited = 19,

        /// <summary>
        ///     Переключение заказа на расчёт по таксометру
        /// </summary>
        OrderSwitchToTaximeter = 20,

        /// <summary>
        ///     Начало обработки предварительного заказа
        /// </summary>
        PreorderExecutionStarted = 21,

        /// <summary>
        ///     Наступление времени выполнения заказа
        /// </summary>
        OrderTimeCome = 22,

        /// <summary>
        ///     Возврат в приложение водителя во время выполнения заказа
        /// </summary>
        DriverApplicationOpened = 23,

        /// <summary>
        ///     Закрытие назначенного заказа водителем
        /// </summary>
        DriverCloseAssignedOrder = 24,

        /// <summary>
        ///     Определение возможности назначения статуса заказу
        /// </summary>
        OrderStatusEstimate = 25,

        /// <summary>
        ///     Определение возможности выполнения предварительного заказа водителем
        /// </summary>
        PreliminaryOrderEstimate = 26,

        /// <summary>
        ///     Подтверждение заказа водителем получено с опозданием
        /// </summary>
        OrderDriverConfirmationReceivedTardily = 27
    }

    /// <summary>
    ///     Операции программы расчёта скидок и бонусов заказа по программе лояльности
    /// </summary>
    public enum OrderLoyalProgProgramActions {
        /// <summary>
        ///     Расчёт заказа
        ///     <para />
        ///     Подготовка параметров расчёта по таксометру (абсолютная и относительная скидка)
        /// </summary>
        OrderCalculation = 0,

        /// <summary>
        ///     Расчёт бонусов при остановке таксометра
        /// </summary>
        StopTaximeterCalculation = 1
    }

    /// <summary>
    ///     Виды статусов заказа в системе обмена
    /// </summary>
    public enum OrderXchgStt {
        /// <summary>
        ///     Не передан в систему обмена
        /// </summary>
        None = 0,

        /// <summary>
        ///     Определяется исполнитель в системе обмена
        /// </summary>
        Processing = 1,

        /// <summary>
        ///     Исполнитель определён
        /// </summary>
        ExecutorDefined = 2
    }

    /// <summary>
    ///     Способ исполнения заказа
    /// </summary>
    public enum OrderExecutionMethod {
        /// <summary>
        ///     Любой
        /// </summary>
        Any = 0,

        /// <summary>
        ///     По тарифу
        /// </summary>
        Tariff = 1,

        /// <summary>
        ///     По таксометру
        /// </summary>
        Taximeter = 2
    }

    /// <summary>
    ///     Источники снятия водителя с заказа
    /// </summary>
    public enum OrderDriverDisappointmentSources {
        /// <summary>
        ///     Вручную диспетчером
        /// </summary>
        ByDispatcher = 0,

        /// <summary>
        ///     Вручную водителем
        /// </summary>
        ByDriver = 1,

        /// <summary>
        ///     Автоматически системой (удаление заказа и т.п.)
        /// </summary>
        BySystem = 2,

        /// <summary>
        ///     Таймаут в процессе автоназначения
        /// </summary>
        Timeout = 3
    }

    /// <summary>
    ///     Типы гридов реестра заказов
    /// </summary>
    public enum OrderGridTypes {
        /// <summary>
        ///     Активный
        /// </summary>
        Active = 0,

        /// <summary>
        ///     Выполняющийся
        /// </summary>
        Running = 1,

        /// <summary>
        ///     Предварительный
        /// </summary>
        Preliminary = 2,

        /// <summary>
        ///     Архивный
        /// </summary>
        Archive = 3,

        /// <summary>
        ///     Диспетчерский
        /// </summary>
        Dispatcher = 4,

        /// <summary>
        ///     Горячий
        /// </summary>
        Hot = 5,

        /// <summary>
        ///     Все
        /// </summary>
        All = 6
    }

    /// <summary>
    ///     Режим выборки данных по пользователю
    /// </summary>
    public enum DataSelectionModeOrders {
        /// <summary>
        ///     Все записи
        /// </summary>
        All,

        /// <summary>
        ///     Принадлежащие пользователю
        /// </summary>
        Owned,

        /// <summary>
        ///     Созданные пользователем
        /// </summary>
        Created,

        /// <summary>
        ///     Контролируемые пользователем
        /// </summary>
        Monitored,

        /// <summary>
        ///     Закрытые пользователем
        /// </summary>
        Closed
    }

    #region Helpers

    public static class OrdersHelper {
        public static OrderEvents EventType( this OrderStt status ) {
            switch( status ) {
            case OrderStt.Created:
                return OrderEvents.Create;
            case OrderStt.CompleteSuccessfully:
            case OrderStt.CompleteUnsuccessfully:
                return OrderEvents.Closure;
            default:
                return OrderEvents.Change;
            }
        }

        public static OrderStt Stt( this OrderSubStt subStatus ) {
            switch( subStatus ) {
            case OrderSubStt.CreatedCreated:
            case OrderSubStt.CreatedCalculating:
            case OrderSubStt.CreatedClientConfirmation:
                return OrderStt.Created;

            case OrderSubStt.CarSearchEstimate:
            case OrderSubStt.CarSearchAuto:
            case OrderSubStt.CarSearchClientSelect:
            case OrderSubStt.CarSearchClientWaitingAnswer:
            case OrderSubStt.CarSearchByDispatcher:
            case OrderSubStt.CarSearchBroadcast:
                return OrderStt.CarSearch;

            case OrderSubStt.CarOnRoadDriverConfirmed:
            case OrderSubStt.CarOnRoadDriverStarts:
            case OrderSubStt.CarOnRoadDriverIsLate:
                return OrderStt.CarOnRoad;

            case OrderSubStt.CarWaitingDriverArrived:
            case OrderSubStt.CarWaitingClientNotified:
            case OrderSubStt.CarWaitingIdleCharges:
                return OrderStt.CarWaiting;

            case OrderSubStt.InProgressWithClient:
            case OrderSubStt.InProgressStartTaximeter:
                return OrderStt.InProgress;

            case OrderSubStt.CompleteWaitPay:
                return OrderStt.Complete;

            case OrderSubStt.CancelledCarNotFound:
            case OrderSubStt.CancelledClientNotOut:
            case OrderSubStt.CancelledDriverRejection:
            case OrderSubStt.CancelledClientRejection:
                return OrderStt.Cancelled;

            case OrderSubStt.CompleteSuccessfullyPayed:
            case OrderSubStt.CompleteSuccessfullyFilingFeesCar:
                return OrderStt.CompleteSuccessfully;

            case OrderSubStt.CompleteUnsuccessfullyCarNotFound:
            case OrderSubStt.CompleteUnsuccessfullyClientRejection:
            case OrderSubStt.CompleteUnsuccessfullyInvalidCalculation:
            case OrderSubStt.CompleteUnsuccessfullyOperatorGuilty:
            case OrderSubStt.CompleteUnsuccessfullyDriverGuilty:
            case OrderSubStt.CompleteUnsuccessfullyInvalidRoute:
            case OrderSubStt.CompleteUnsuccessfullyClientNotSelect:
            case OrderSubStt.CompleteUnsuccessfullyCarSearchCancellation:
                return OrderStt.CompleteUnsuccessfully;

            default:
                throw new ArgumentOutOfRangeException( nameof(subStatus), subStatus, "Invalid value" );
            }
        }
    }

    #endregion
}
