﻿using System;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using YTxCommon.App.Enums;

namespace ServerAppAPI.API.Common {
    internal class XchgCarInfo {
        public int Id { get; set; }
        public string StateNum { get; set; }

        [JsonConverter( typeof( StringEnumConverter ) )]
        public CarStt Status { get; set; }

        public string StatusNote { get; set; }

        public string RegCert { get; set; }

        [JsonConverter( typeof( StringEnumConverter ) )]
        public CarOwnTypes OwnType { get; set; }

        public int ModelId { get; set; }
        public string MakerName { get; set; }
        public string ModelName { get; set; }
        public int ColorId { get; set; }
        public string ColorName { get; set; }
        public int ModelYear { get; set; }

        public DateTime? Created { get; set; }

        [JsonProperty( ItemConverterType = typeof( StringEnumConverter ) )]
        public CarClasses[] CarClasses { get; set; }

        [JsonProperty( ItemConverterType = typeof( StringEnumConverter ) )]
        public OrderTypes[] OrderTypes { get; set; }

        public string Note { get; set; }
        public string Endorsements { get; set; }
    }
}
