﻿using System;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using YTxCommon.App.Enums;

namespace ServerAppAPI.API.Common {
    internal class XchgDriverInfo {
        public string Login { get; set; }

        public string PasswordHash { get; set; }
        public string PasswordSeed { get; set; }

        public int Id { get; set; }

        public string FirstName { get; set; }
        public string LastName { get; set; }
        public string MiddleName { get; set; }

        [JsonConverter( typeof( StringEnumConverter ) )]
        public DriverStt Status { get; set; }

        public string StatusNote { get; set; }

        public string WorkPhone { get; set; }
        public string ContactPhone { get; set; }
        public string HomePhone { get; set; }
        public string AdditionalPhone1 { get; set; }
        public string AdditionalPhone2 { get; set; }

        [JsonConverter( typeof( StringEnumConverter ) )]
        public Gender Gender { get; set; }

        public DateTime? Birthdate { get; set; }
        public DateTime? Employed { get; set; }

        [JsonProperty( ItemConverterType = typeof( StringEnumConverter ) )]
        public OrderTypes[] OrderTypes { get; set; }

        public XchgCarInfo[] Cars { get; set; }

        public string BankCardNum { get; set; }
        public string PaymentPhone { get; set; }

        public bool AcceptBankCard { get; set; }

        public int WorkingPeriod { get; set; }

        public string PassportSerialAndNum { get; set; }
        public string PassportVendor { get; set; }
        public DateTime? PassportDate { get; set; }
        public string PassportAddress { get; set; }
        public string RealAddress { get; set; }

        public string DriverLicenseSerialAndNum { get; set; }
        public string DriverCategory { get; set; }

        public string DriverNote { get; set; }

        public string PhotoJpegBase64 { get; set; }
        public string LicensePhotoFrontJpegBase64 { get; set; }
        public string LicensePhotoBackJpegBase64 { get; set; }

        public string PactBase64 { get; set; }
    }
}
