﻿using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using YTxCommon;
using YTxCommon.App.Enums;

namespace ServerAppAPI.API.Requests {
    internal class RequestAvailableDriversQuery : Request {
        [JsonConverter( typeof( StringEnumConverter ) )]
        public SysLangs Lang { get; set; }

        [JsonProperty( ItemConverterType = typeof( StringEnumConverter ) )]
        public CarClasses[] CarClasses { get; set; }

        [JsonProperty( ItemConverterType = typeof( StringEnumConverter ) )]
        public OrderTypes[] OrderTypes { get; set; }

        public bool IncludeOffline { get; set; }
        public bool IncludeBusy { get; set; }
        public bool IncludeAvailableByXchgCash { get; set; }
        public bool IncludeAvailableByXchgNonCash { get; set; }

        [OnSerializing]
        internal void OnSerializingMethod( StreamingContext context ) {
            Command = Commands.AvailableDriversQuery;
        }
    }
}
