﻿using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using YTxCommon;
using YTxCommon.App.Enums;

namespace ServerAppAPI.API.Requests {
    internal class RequestClientAccountRegistration : Request {
        [JsonConverter( typeof( StringEnumConverter ) )]
        public SysLangs Lang { get; set; }

        public string ClientPhone { get; set; }

        [JsonConverter( typeof( StringEnumConverter ) )]
        public PaymentAccountTypes AccountType { get; set; }

        [JsonConverter( typeof( StringEnumConverter ) )]
        public PaymentSystems? PaymentSystem { get; set; }

        public string CellularPhone { get; set; }

        public string Name { get; set; }
        public string Note { get; set; }

        [OnSerializing]
        internal void OnSerializingMethod( StreamingContext context ) {
            Command = Commands.ClientAccountRegistration;
        }
    }
}
