﻿using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using YTxCommon;
using YTxCommon.App.Enums;

namespace ServerAppAPI.API.Requests {
    internal class RequestConsumersRelationsInfoSet : Request {
        [JsonConverter( typeof( StringEnumConverter ) )]
        public SysLangs Lang { get; set; }

        public string PhoneParent { get; set; }
        public string PhoneChild { get; set; }

        [JsonConverter( typeof( StringEnumConverter ) )]
        public ConsumerRelations RelationType { get; set; }

        public bool Remove { get; set; }

        [OnSerializing]
        internal void OnSerializingMethod( StreamingContext context ) {
            Command = Commands.ConsumersRelationsInfoSet;
        }
    }
}
