﻿using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using YTxCommon;
using YTxCommon.App.Enums;

namespace ServerAppAPI.API.Requests {
    internal class RequestDriversRelationsInfoSet : Request {
        [JsonConverter( typeof( StringEnumConverter ) )]
        public SysLangs Lang { get; set; }

        public string ClientPhone { get; set; }
        public int DriverId { get; set; }

        [JsonConverter( typeof( StringEnumConverter ) )]
        public DriverClientRelations RelationType { get; set; }

        public bool Remove { get; set; }

        [OnSerializing]
        internal void OnSerializingMethod( StreamingContext context ) {
            Command = Commands.DriversRelationsInfoSet;
        }
    }
}
