using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using YTxCommon;

namespace ServerAppAPI.API.Requests {
    internal class RequestGeoDataQuery : Request {
        [JsonConverter( typeof( StringEnumConverter ) )]
        public SysLangs Lang { get; set; }

        [JsonConverter( typeof( StringEnumConverter ) )]
        public GeoDataRequestTypes RequestType { get; set; }

        public string TownName { get; set; }

        public string StreetName { get; set; }

        public string HouseName { get; set; }

        public string PlaceName { get; set; }

        public bool UseRegExp { get; set; }

        [OnSerializing]
        internal void OnSerializingMethod( StreamingContext context ) {
            Command = Commands.GeoDataQuery;
        }
    }
}
