﻿using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using YTxCommon;

namespace ServerAppAPI.API.Requests {
    internal class RequestXchgDriverInfoQuery : Request {
        [JsonConverter( typeof( StringEnumConverter ) )]
        public SysLangs Lang { get; set; }

        public string Login { get; set; }

        // PasswordSeed = MD5(Upper(Login))
        // PasswordHash = MD5(Password + PasswordSeed)

        public string PasswordHash { get; set; }
        public string PasswordSeed { get; set; }

        public bool IncludeCars { get; set; }
        public bool IncludePact { get; set; }
        public bool IncludePhoto { get; set; }
        public bool IncludeLicense { get; set; }

        public int MaxWidth { get; set; }
        public int MaxHeight { get; set; }

        [OnSerializing]
        internal void OnSerializingMethod( StreamingContext context ) {
            Command = Commands.XchgDriverInfoQuery;
        }
    }
}
