﻿using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using ServerAppAPI.API.Common;
using YTxCommon;

namespace ServerAppAPI.API.Requests {
    internal class RequestXchgDriverInfoSet : Request {
        [JsonConverter( typeof( StringEnumConverter ) )]
        public SysLangs Lang { get; set; }

        public bool IncludeCars { get; set; }
        public bool IncludePact { get; set; }
        public bool IncludePhoto { get; set; }
        public bool IncludeLicense { get; set; }

        public bool DropOrInactive { get; set; }

        public XchgDriverInfo DriverInfo { get; set; }

        [OnSerializing]
        internal void OnSerializingMethod( StreamingContext context ) {
            Command = Commands.XchgDriverInfoSet;
        }
    }
}
