﻿using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using YTxCommon.App.Enums;

namespace ServerAppAPI.API.Responses {
    internal class ResponseProviderInfoQuery : Response {
        public string Name { get; set; }
        public string Description { get; set; }
        public int? TownId { get; set; }
        public string TownName { get; set; }
        public double TownGPSLat { get; set; }
        public double TownGPSLon { get; set; }
        public string PhonePrefix { get; set; }
        public string CurrencyCode { get; set; }
        public string[] DispatchPhones { get; set; }
        public int PreorderStartInterval { get; set; }
        public int OrderCarSearchPeriod { get; set; }
        public int DriverConfirmOrderProcessingTime { get; set; }
        public int DriverConfirmOrderClaimedProcessingTime { get; set; }
        public bool RoundOrderPaySum { get; set; }
        public bool UseTaximeter { get; set; }
        public bool TaximeterAlways { get; set; }
        public bool TaximeterRunsForAllOrders { get; set; }
        public bool TaximeterBackgroundShowPaySum { get; set; }
        public bool TaximeterAllowPause { get; set; }
        public bool TaximeterAllowNonPaidPause { get; set; }
        public bool TaximeterSetsFinishOrderPoint { get; set; }

        public bool TaximeterTariffsPresent { get; set; }

        [JsonConverter( typeof( StringEnumConverter ) )]
        public CarClasses DefaultCarClass { get; set; }

        [JsonProperty( ItemConverterType = typeof( StringEnumConverter ) )]
        public CarClasses[] ExcludedCarClasses { get; set; }

        [JsonProperty( ItemConverterType = typeof( StringEnumConverter ) )]
        public OrderTypes[] ExcludedOrderTypes { get; set; }

        public PaymentSystemProperties[] PaymentSystemsAvailable { get; set; }
    }

    internal class PaymentSystemProperties {
        [JsonConverter( typeof( StringEnumConverter ) )]
        public PaymentSystems PaymentSystem { get; set; }

        [JsonProperty( ItemConverterType = typeof( StringEnumConverter ) )]
        public PaymentAccountTypes[] AccountTypes { get; set; }
    }
}
